<template>
  <v-page :header-text="headerText">
    <input
        v-model="email"
        :disabled="inProgress"
        type="email"
        placeholder="Email"
        ref="emailInput"
        @input="onInput"
        @keyup.enter="onSignIn"
    />
    <br/>
    <input
        v-model="pass"
        :disabled="inProgress"
        type="password"
        placeholder="Password"
        class="input-password"
        ref="passInput"
        @input="onInput"
        @keyup.enter="onSignIn"
    />
    <FormErrorMessage v-if="error">{{ error }}</FormErrorMessage>
    <br/>
    <v-button-link :disabled="inProgress" to="/reset-pass" class="button-forgot-pass">forgot password</v-button-link>
    <br/>
    <v-button :in-progress="inProgress" @click="onSignIn">Sign in</v-button>
    <br/>
    <v-button-link :disabled="inProgress" to="/sign-up">sign up</v-button-link>
    <div class="social-sign-in-container">
      <v-icon-button
          :disabled="inProgress"
          :src="require('@/asset/social/facebook.png')"
          class="button-social-sign-in"
          width="40"
          @click="onFacebookSignIn"
      />
      <v-icon-button
          :disabled="inProgress"
          :src="require('@/asset/social/google.png')"
          class="button-social-sign-in"
          width="40"
          @click="onGoogleSignIn"
      />
    </div>
  </v-page>
</template>

<script>
  import { createNamespacedHelpers } from 'vuex'

  import { animateError, FormErrorMessage, VButton, VButtonLink, VPage } from 'zeus-common'
  import { SignInError } from '@/common/sign-in/service'
  import { ButtonSignInFinished, header as headerText } from '@/config'
  import VIconButton from 'zeus-common/src/component/button/VIconButton'

  const { mapState } = createNamespacedHelpers('signIn')

  export default {
    name: 'SignInPage',
    components: { VIconButton, FormErrorMessage, VPage, VButton, VButtonLink },
    data: () => ({
      headerText: headerText,
      email: '',
      pass: ''
    }),
    computed: {
      ...mapState([ 'inProgress', 'error' ])
    },
    beforeDestroy() {
      this.$store.commit('signIn/resetError')
    },
    watch: {
      error(error) { switch (error) {
        case SignInError.NoSuchEmail:
          animateError(this.$refs.emailInput)
          break
        case SignInError.IncorrectPassword:
          animateError(this.$refs.passInput)
          break
        case SignInError.EmailIsNotConfirmed:
          this.$store.commit('confirmationEmailSent/setCredentials', { email: this.email, pass: this.pass })
          this.$router.push('/confirmation-email-sent')
          break
        default: break
      }}
    },
    methods: {
      onSignedIn() {
        ButtonSignInFinished.go()
      },
      onSignIn() {
        this.onInput()
        let errorCounter = 0

        if (!this.email) {
          animateError(this.$refs.emailInput)
          errorCounter++
        }
        if (!this.pass) {
          animateError(this.$refs.passInput)
          errorCounter++
        }
        if (errorCounter === 0) {
          this.$store.dispatch('signIn/signIn', {
            email: this.email,
            pass: this.pass,
            onSuccess: this.onSignedIn
          })
        }
      },
      onInput() {
        if (this.error != null) {
          this.$store.commit('signIn/resetError')
        }
      },
      onFacebookSignIn() {
        this.$store.dispatch('signIn/signInWithFacebook', this.onSignedIn)
      },
      onGoogleSignIn() {
        this.$store.dispatch('signIn/signInWithGoogle', this.onSignedIn)
      }
    }
  }
</script>

<style scoped lang="scss">
  .button-forgot-pass {
    margin-bottom: -0.3em;
  }

  .input-password {
    margin-bottom: 0.9em;
  }

  .social-sign-in-container {
    margin-top: 2.05em;

    .button-social-sign-in {
      margin: 0 1.1em;
    }
  }
</style>